/**
 * What happens when both the try and the finally clause
 * try to return a value?  Which takes precedence?
 *<P>
 * Source: Peter Haggar, "Effective Exception Handling in Java",
 * The Java Report, April 1999, pp. 55-77.
 **/
class Puzzle5 extends AbstractPuzzle {
	class A {
		int m() {
			try { return 1; }
			catch (Exception err) { return 2; }
			finally { return 3; }
		}
	}

	/**
	 * Evaluate: (new Puzzle5()).run();
	 **/
	void run() {
		super.run();

		A a = new A();
		println(a.m()); // 1, 2 or 3?
	}
}
